## GstTagSetter GstTagSetter — Element interface that allows setting and retrieval of media metadata |

## Functions

void | gst_tag_setter_reset_tags ()
void | gst_tag_setter_merge_tags ()
void | gst_tag_setter_add_tags ()
void | gst_tag_setter_add_tag_value ()
void | gst_tag_setter_add_tag_values ()
void | gst_tag_setter_add_tag_valist ()
void | gst_tag_setter_add_tag_valist_values ()
const GstTagList * | gst_tag_setter_get_tag_list ()
void | gst_tag_setter_set_tag_merge_mode ()
GstTagMergeMode | gst_tag_setter_get_tag_merge_mode ()

## Types and Values

| GstTagSetter
struct | GstTagSetterInterface

## Object Hierarchy

        GInterface
        ╰── GstTagSetter

## Prerequisites

GstTagSetter requires GstElement.

## Includes

    #include <gst/gst.h>

## Description

Element interface that allows setting of media metadata.

Elements that support changing a stream's metadata will implement this interface. Examples of such elements are 'vorbisenc', 'theoraenc' and 'id3v2mux'.

If you just want to retrieve metadata in your application then all you need to do is watch for tag messages on your pipeline's bus. This interface is only for setting metadata, not for extracting it. To set tags from the application, find tagsetter elements and set tags using e.g. `gst_tag_setter_merge_tags()` or `gst_tag_setter_add_tags()`. Also consider setting the GstTagMergeMode that is used for tag events that arrive at the tagsetter element (default mode is to keep existing tags). The application should do that before the element goes to `GST_STATE_PAUSED`.

Elements implementing the GstTagSetter interface often have to merge any tags received from upstream and the tags set by the application via the interface. This can be done like this:

    1
    2
    3
    4
    5
    6
    7
    8
    9
    10
    11
    12
    13
    14
    15
    16
    17
    18
    19
    GstTagMergeMode merge_mode;
    const GstTagList *application_tags;
    const GstTagList *event_tags;
    GstTagSetter *tagsetter;
    GstTagList *result;

    tagsetter = GST_TAG_SETTER (element);

    merge_mode = gst_tag_setter_get_tag_merge_mode (tagsetter);
    application_tags = gst_tag_setter_get_tag_list (tagsetter);
    event_tags = (const GstTagList *) element->event_tags;

    GST_LOG_OBJECT (tagsetter, "merging tags, merge mode = %d", merge_mode);
    GST_LOG_OBJECT (tagsetter, "event tags: %" GST_PTR_FORMAT, event_tags);
    GST_LOG_OBJECT (tagsetter, "set   tags: %" GST_PTR_FORMAT, application_tags);

    result = gst_tag_list_merge (application_tags, event_tags, merge_mode);

    GST_LOG_OBJECT (tagsetter, "final tags: %" GST_PTR_FORMAT, result);

## Functions

### gst_tag_setter_reset_tags ()

    void
    gst_tag_setter_reset_tags (GstTagSetter *setter);

Reset the internal taglist. Elements should call this from within the state-change handler.

#### Parameters

setter | a GstTagSetter |

### gst_tag_setter_merge_tags ()

    void
    gst_tag_setter_merge_tags (GstTagSetter *setter,
                               const GstTagList *list,
                               GstTagMergeMode mode);

Merges the given list into the setter's list using the given mode.

#### Parameters

setter | a GstTagSetter |
list | a tag list to merge from |
mode | the mode to merge with |

### gst_tag_setter_add_tags ()

    void
    gst_tag_setter_add_tags (GstTagSetter *setter,
                             GstTagMergeMode mode,
                             const gchar *tag,
                             ...);

Adds the given tag / value pairs on the setter using the given merge mode. The list must be terminated with `NULL`.

#### Parameters

setter | a GstTagSetter |
mode | the mode to use |
tag | tag to set |
... | more tag / value pairs to set |

### gst_tag_setter_add_tag_value ()

    void
    gst_tag_setter_add_tag_value (GstTagSetter *setter,
                                  GstTagMergeMode mode,
                                  const gchar *tag,
                                  const GValue *value);

Adds the given tag / GValue pair on the setter using the given merge mode.

#### Parameters

setter | a GstTagSetter |
mode | the mode to use |
tag | tag to set |
value | GValue to set for the tag |

### gst_tag_setter_add_tag_values ()

    void
    gst_tag_setter_add_tag_values (GstTagSetter *setter,
                                   GstTagMergeMode mode,
                                   const gchar *tag,
                                   ...);

Adds the given tag / GValue pairs on the setter using the given merge mode. The list must be terminated with `NULL`.

#### Parameters

setter | a GstTagSetter |
mode | the mode to use |
tag | tag to set |
... | more tag / GValue pairs to set |

### gst_tag_setter_add_tag_valist ()

    void
    gst_tag_setter_add_tag_valist (GstTagSetter *setter,
                                   GstTagMergeMode mode,
                                   const gchar *tag,
                                   va_list var_args);

Adds the given tag / value pairs on the setter using the given merge mode. The list must be terminated with `NULL`.

#### Parameters

setter | a GstTagSetter |
mode | the mode to use |
tag | tag to set |
var_args | tag / value pairs to set |

### gst_tag_setter_add_tag_valist_values ()

    void
    gst_tag_setter_add_tag_valist_values (GstTagSetter *setter,
                                          GstTagMergeMode mode,
                                          const gchar *tag,
                                          va_list var_args);

Adds the given tag / GValue pairs on the setter using the given merge mode. The list must be terminated with `NULL`.

#### Parameters

setter | a GstTagSetter |
mode | the mode to use |
tag | tag to set |
var_args | tag / GValue pairs to set |

### gst_tag_setter_get_tag_list ()

    const GstTagList *
    gst_tag_setter_get_tag_list (GstTagSetter *setter);

Returns the current list of tags the setter uses. The list should not be modified or freed.

This function is not thread-safe.

#### Parameters

setter | a GstTagSetter |

#### Returns

a current snapshot of the taglist used in the setter or `NULL` if none is used.

[transfer none][nullable]

### gst_tag_setter_set_tag_merge_mode ()

    void
    gst_tag_setter_set_tag_merge_mode (GstTagSetter *setter,
                                       GstTagMergeMode mode);

Sets the given merge mode that is used for adding tags from events to tags specified by this interface. The default is GST_TAG_MERGE_KEEP, which keeps the tags set with this interface and discards tags from events.

#### Parameters

setter | a GstTagSetter |
mode | The mode with which tags are added |

### gst_tag_setter_get_tag_merge_mode ()

    GstTagMergeMode
    gst_tag_setter_get_tag_merge_mode (GstTagSetter *setter);

Queries the mode by which tags inside the setter are overwritten by tags from events

#### Parameters

setter | a GstTagSetter |

#### Returns

the merge mode used inside the element.

## Types and Values

### GstTagSetter

    typedef struct _GstTagSetter GstTagSetter;

Opaque GstTagSetter data structure.

### struct GstTagSetterInterface

    struct GstTagSetterInterface {
      GTypeInterface g_iface;

      /* signals */

      /* virtual table */
    };

GstTagSetterInterface interface.

#### Members